<template>
  <div>
    <div v-if="action">
      <div
        v-if="action.name"
        class="q-title"
      >{{ action.name }}</div>
      <div
        v-if="action.description"
        class="q-subtitle"
      >
        {{ action.description }}
      </div>
      <div
        class="q-mt-md"
      >
        <group
          :group="action"
          :record="payload"
          :as-card="false"
        />
        <div class="q-mt-lg flex justify-end q-px-md">
          <q-btn
            :label="action.buttonText"
            color="primary"
            size="md"
            @click="submit"
            :loading="isProcessing"
          :disable="isProcessing"
        />
      </div>
    </div>
  </div>
  <q-modal
    :value="!!response"
    @hide="response = null"
  >
    <div class="q-pa-md">
      <div class="q-title">Response:</div>
      <pre>{{ JSON.stringify(response, null, 2) }}</pre>
    </div>
  </q-modal>
  </div>
</template>

<script>
  import Group from '../../../redactor/group';
  import apiMixin from '../../../../mixins/apiMixin';
  import notificationMixin from '../../../../mixins/notificationMixin';

  export default {
    name: 'action',
    mixins: [apiMixin, notificationMixin],
    components: { Group },
    props: {
      action: {
        type: Object,
      },
    },
    watch: {
      // eslint-disable-next-line
      '$store.state.location.location.id': function() {
        this.action.fields.forEach(({ type, config }) => {
          if (['dropdown', 'collection'].indexOf(type) > -1) {
            const value = config.field === 'location_id' ? this.$store.state.location.location.id : null;
            // eslint-disable-next-line no-nested-ternary
            this.payload[config.field] = config.isMultiple ? (value ? [value] : []) : (value || null);
          }
        });
      },
      action: {
        deep: true,
        handler() {
          this.$nextTick(() => {
            this.formPayload();
          });
        },
      },
    },
    created() {
      this.formPayload();
    },
    data() {
      return {
        isProcessing: false,
        payload: {},
        response: null,
      };
    },
    methods: {
      formPayload() {
        const payload = {};

        if (this.action) {
          this.action.fields.forEach(({ type, config }) => {
            if (['dropdown', 'collection'].indexOf(type) > -1) {
              const value = config.field === 'location_id' ? this.$store.state.location.location.id : null;
              // eslint-disable-next-line no-nested-ternary
              payload[config.field] = config.isMultiple ? (value ? [value] : []) : (value || null);
            } else if (type === 'checkbox') {
              payload[config.field] = false;
            } else {
              payload[config.field] = null;
            }
          });
        }

        this.payload = { ...payload };
      },
      processRequest() {
        const { endpoint } = this.action;
        const params = this.payload;

        const method = {
          GET: () => this.apiGet(endpoint, { params }),
          POST: () => this.apiPost(endpoint, params),
          PUT: () => this.apiPut(endpoint, params),
          DELETE: () => this.apiDelete(endpoint, params),
        }[this.action.method];

        method()
          .then((res) => {
            this.response = res;
          })
          .catch(() => {
            this.notifyError({
              title: 'Unable to process action',
            });
          });

        this.isProcessing = false;
      },
      submit() {
        this.isProcessing = true;

        if (this.action.useConfirmation) {
          this.$q.dialog({
            title: 'Confirm action',
            message: this.action.confirmationText,
            ok: true,
            cancel: true,
          })
            .then(() => {
              this.processRequest();
            })
            .catch(() => {
              this.isProcessing = false;
            });
        } else {
          this.processRequest();
        }
      },
    },
  };
</script>
